import 'package:poker/poker.dart';
import "package:benchmark_harness/benchmark_harness.dart";

class SimulatorInitializationBenchmark extends BenchmarkBase {
  SimulatorInitializationBenchmark()
      : super("SimulatorInitializationBenchmark");

  void run() {
    Simulator(
      communityCards: {},
      handRanges: [
        HandRange({
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.king, kicker: Rank.queen),
          RankPair.suited(high: Rank.king, kicker: Rank.jack),
          RankPair.suited(high: Rank.king, kicker: Rank.ten),
          RankPair.suited(high: Rank.king, kicker: Rank.nine),
          RankPair.suited(high: Rank.king, kicker: Rank.eight),
          RankPair.suited(high: Rank.king, kicker: Rank.seven),
          RankPair.suited(high: Rank.king, kicker: Rank.six),
          RankPair.suited(high: Rank.king, kicker: Rank.five),
          RankPair.suited(high: Rank.king, kicker: Rank.four),
          RankPair.suited(high: Rank.king, kicker: Rank.three),
          RankPair.suited(high: Rank.king, kicker: Rank.deuce),
          RankPair.suited(high: Rank.queen, kicker: Rank.jack),
          RankPair.suited(high: Rank.queen, kicker: Rank.ten),
          RankPair.suited(high: Rank.queen, kicker: Rank.nine),
          RankPair.suited(high: Rank.queen, kicker: Rank.eight),
          RankPair.suited(high: Rank.queen, kicker: Rank.seven),
          RankPair.suited(high: Rank.queen, kicker: Rank.six),
          RankPair.suited(high: Rank.queen, kicker: Rank.five),
          RankPair.suited(high: Rank.jack, kicker: Rank.ten),
          RankPair.suited(high: Rank.jack, kicker: Rank.nine),
          RankPair.suited(high: Rank.jack, kicker: Rank.eight),
          RankPair.suited(high: Rank.jack, kicker: Rank.seven),
          RankPair.suited(high: Rank.ten, kicker: Rank.nine),
          RankPair.suited(high: Rank.ten, kicker: Rank.eight),
          RankPair.suited(high: Rank.ten, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.nine, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.eight, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.five),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.suited(high: Rank.seven, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.four),
          RankPair.suited(high: Rank.five, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
        }),
        HandRange({
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.king, kicker: Rank.queen),
          RankPair.suited(high: Rank.king, kicker: Rank.jack),
          RankPair.suited(high: Rank.king, kicker: Rank.ten),
          RankPair.suited(high: Rank.king, kicker: Rank.nine),
          RankPair.suited(high: Rank.king, kicker: Rank.eight),
          RankPair.suited(high: Rank.king, kicker: Rank.seven),
          RankPair.suited(high: Rank.king, kicker: Rank.six),
          RankPair.suited(high: Rank.king, kicker: Rank.five),
          RankPair.suited(high: Rank.king, kicker: Rank.four),
          RankPair.suited(high: Rank.king, kicker: Rank.three),
          RankPair.suited(high: Rank.king, kicker: Rank.deuce),
          RankPair.suited(high: Rank.queen, kicker: Rank.jack),
          RankPair.suited(high: Rank.queen, kicker: Rank.ten),
          RankPair.suited(high: Rank.queen, kicker: Rank.nine),
          RankPair.suited(high: Rank.queen, kicker: Rank.eight),
          RankPair.suited(high: Rank.queen, kicker: Rank.seven),
          RankPair.suited(high: Rank.queen, kicker: Rank.six),
          RankPair.suited(high: Rank.queen, kicker: Rank.five),
          RankPair.suited(high: Rank.jack, kicker: Rank.ten),
          RankPair.suited(high: Rank.jack, kicker: Rank.nine),
          RankPair.suited(high: Rank.jack, kicker: Rank.eight),
          RankPair.suited(high: Rank.jack, kicker: Rank.seven),
          RankPair.suited(high: Rank.ten, kicker: Rank.nine),
          RankPair.suited(high: Rank.ten, kicker: Rank.eight),
          RankPair.suited(high: Rank.ten, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.nine, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.eight, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.five),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.suited(high: Rank.seven, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.four),
          RankPair.suited(high: Rank.five, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
        }),
        HandRange({
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
        HandRange({
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
        HandRange({
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
        HandRange({
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
      ],
    );
  }
}

class SimulatorEvaluationBenchmark extends BenchmarkBase {
  SimulatorEvaluationBenchmark() : super("SimulatorEvaluationBenchmark");

  Simulator simulator;

  void setup() {
    simulator = Simulator(
      communityCards: {},
      handRanges: [
        HandRange({
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.king, kicker: Rank.queen),
          RankPair.suited(high: Rank.king, kicker: Rank.jack),
          RankPair.suited(high: Rank.king, kicker: Rank.ten),
          RankPair.suited(high: Rank.king, kicker: Rank.nine),
          RankPair.suited(high: Rank.king, kicker: Rank.eight),
          RankPair.suited(high: Rank.king, kicker: Rank.seven),
          RankPair.suited(high: Rank.king, kicker: Rank.six),
          RankPair.suited(high: Rank.king, kicker: Rank.five),
          RankPair.suited(high: Rank.king, kicker: Rank.four),
          RankPair.suited(high: Rank.king, kicker: Rank.three),
          RankPair.suited(high: Rank.king, kicker: Rank.deuce),
          RankPair.suited(high: Rank.queen, kicker: Rank.jack),
          RankPair.suited(high: Rank.queen, kicker: Rank.ten),
          RankPair.suited(high: Rank.queen, kicker: Rank.nine),
          RankPair.suited(high: Rank.queen, kicker: Rank.eight),
          RankPair.suited(high: Rank.queen, kicker: Rank.seven),
          RankPair.suited(high: Rank.queen, kicker: Rank.six),
          RankPair.suited(high: Rank.queen, kicker: Rank.five),
          RankPair.suited(high: Rank.jack, kicker: Rank.ten),
          RankPair.suited(high: Rank.jack, kicker: Rank.nine),
          RankPair.suited(high: Rank.jack, kicker: Rank.eight),
          RankPair.suited(high: Rank.jack, kicker: Rank.seven),
          RankPair.suited(high: Rank.ten, kicker: Rank.nine),
          RankPair.suited(high: Rank.ten, kicker: Rank.eight),
          RankPair.suited(high: Rank.ten, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.nine, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.eight, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.five),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.suited(high: Rank.seven, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.four),
          RankPair.suited(high: Rank.five, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
        }),
        HandRange({
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.king, kicker: Rank.queen),
          RankPair.suited(high: Rank.king, kicker: Rank.jack),
          RankPair.suited(high: Rank.king, kicker: Rank.ten),
          RankPair.suited(high: Rank.king, kicker: Rank.nine),
          RankPair.suited(high: Rank.king, kicker: Rank.eight),
          RankPair.suited(high: Rank.king, kicker: Rank.seven),
          RankPair.suited(high: Rank.king, kicker: Rank.six),
          RankPair.suited(high: Rank.king, kicker: Rank.five),
          RankPair.suited(high: Rank.king, kicker: Rank.four),
          RankPair.suited(high: Rank.king, kicker: Rank.three),
          RankPair.suited(high: Rank.king, kicker: Rank.deuce),
          RankPair.suited(high: Rank.queen, kicker: Rank.jack),
          RankPair.suited(high: Rank.queen, kicker: Rank.ten),
          RankPair.suited(high: Rank.queen, kicker: Rank.nine),
          RankPair.suited(high: Rank.queen, kicker: Rank.eight),
          RankPair.suited(high: Rank.queen, kicker: Rank.seven),
          RankPair.suited(high: Rank.queen, kicker: Rank.six),
          RankPair.suited(high: Rank.queen, kicker: Rank.five),
          RankPair.suited(high: Rank.jack, kicker: Rank.ten),
          RankPair.suited(high: Rank.jack, kicker: Rank.nine),
          RankPair.suited(high: Rank.jack, kicker: Rank.eight),
          RankPair.suited(high: Rank.jack, kicker: Rank.seven),
          RankPair.suited(high: Rank.ten, kicker: Rank.nine),
          RankPair.suited(high: Rank.ten, kicker: Rank.eight),
          RankPair.suited(high: Rank.ten, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.nine, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.eight, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.five),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.suited(high: Rank.seven, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.four),
          RankPair.suited(high: Rank.five, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
        }),
        HandRange({
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
        HandRange({
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
        HandRange({
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
        HandRange({
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
      ],
    );
  }

  void teardown() {
    simulator = null;
  }

  void run() {
    simulator.evaluate();
  }
}

class MatchupBestHandEvaluationBenchmark extends BenchmarkBase {
  MatchupBestHandEvaluationBenchmark()
      : super("MatchupBestHandEvaluationBenchmark");

  Matchup matchup;

  void setup() {
    final simulator = Simulator(
      communityCards: {},
      handRanges: [
        HandRange({
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.king, kicker: Rank.queen),
          RankPair.suited(high: Rank.king, kicker: Rank.jack),
          RankPair.suited(high: Rank.king, kicker: Rank.ten),
          RankPair.suited(high: Rank.king, kicker: Rank.nine),
          RankPair.suited(high: Rank.king, kicker: Rank.eight),
          RankPair.suited(high: Rank.king, kicker: Rank.seven),
          RankPair.suited(high: Rank.king, kicker: Rank.six),
          RankPair.suited(high: Rank.king, kicker: Rank.five),
          RankPair.suited(high: Rank.king, kicker: Rank.four),
          RankPair.suited(high: Rank.king, kicker: Rank.three),
          RankPair.suited(high: Rank.king, kicker: Rank.deuce),
          RankPair.suited(high: Rank.queen, kicker: Rank.jack),
          RankPair.suited(high: Rank.queen, kicker: Rank.ten),
          RankPair.suited(high: Rank.queen, kicker: Rank.nine),
          RankPair.suited(high: Rank.queen, kicker: Rank.eight),
          RankPair.suited(high: Rank.queen, kicker: Rank.seven),
          RankPair.suited(high: Rank.queen, kicker: Rank.six),
          RankPair.suited(high: Rank.queen, kicker: Rank.five),
          RankPair.suited(high: Rank.jack, kicker: Rank.ten),
          RankPair.suited(high: Rank.jack, kicker: Rank.nine),
          RankPair.suited(high: Rank.jack, kicker: Rank.eight),
          RankPair.suited(high: Rank.jack, kicker: Rank.seven),
          RankPair.suited(high: Rank.ten, kicker: Rank.nine),
          RankPair.suited(high: Rank.ten, kicker: Rank.eight),
          RankPair.suited(high: Rank.ten, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.nine, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.eight, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.five),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.suited(high: Rank.seven, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.four),
          RankPair.suited(high: Rank.five, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
        }),
        HandRange({
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.king, kicker: Rank.queen),
          RankPair.suited(high: Rank.king, kicker: Rank.jack),
          RankPair.suited(high: Rank.king, kicker: Rank.ten),
          RankPair.suited(high: Rank.king, kicker: Rank.nine),
          RankPair.suited(high: Rank.king, kicker: Rank.eight),
          RankPair.suited(high: Rank.king, kicker: Rank.seven),
          RankPair.suited(high: Rank.king, kicker: Rank.six),
          RankPair.suited(high: Rank.king, kicker: Rank.five),
          RankPair.suited(high: Rank.king, kicker: Rank.four),
          RankPair.suited(high: Rank.king, kicker: Rank.three),
          RankPair.suited(high: Rank.king, kicker: Rank.deuce),
          RankPair.suited(high: Rank.queen, kicker: Rank.jack),
          RankPair.suited(high: Rank.queen, kicker: Rank.ten),
          RankPair.suited(high: Rank.queen, kicker: Rank.nine),
          RankPair.suited(high: Rank.queen, kicker: Rank.eight),
          RankPair.suited(high: Rank.queen, kicker: Rank.seven),
          RankPair.suited(high: Rank.queen, kicker: Rank.six),
          RankPair.suited(high: Rank.queen, kicker: Rank.five),
          RankPair.suited(high: Rank.jack, kicker: Rank.ten),
          RankPair.suited(high: Rank.jack, kicker: Rank.nine),
          RankPair.suited(high: Rank.jack, kicker: Rank.eight),
          RankPair.suited(high: Rank.jack, kicker: Rank.seven),
          RankPair.suited(high: Rank.ten, kicker: Rank.nine),
          RankPair.suited(high: Rank.ten, kicker: Rank.eight),
          RankPair.suited(high: Rank.ten, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.nine, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.eight, kicker: Rank.six),
          RankPair.suited(high: Rank.eight, kicker: Rank.five),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.suited(high: Rank.seven, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.five),
          RankPair.suited(high: Rank.six, kicker: Rank.four),
          RankPair.suited(high: Rank.five, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.four),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.ten),
        }),
        HandRange({
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
        HandRange({
          RankPair.suited(high: Rank.ace, kicker: Rank.deuce),
          RankPair.suited(high: Rank.ace, kicker: Rank.three),
          RankPair.suited(high: Rank.ace, kicker: Rank.four),
          RankPair.suited(high: Rank.ace, kicker: Rank.five),
          RankPair.suited(high: Rank.ace, kicker: Rank.six),
          RankPair.suited(high: Rank.ace, kicker: Rank.seven),
          RankPair.suited(high: Rank.ace, kicker: Rank.eight),
          RankPair.suited(high: Rank.ace, kicker: Rank.nine),
          RankPair.suited(high: Rank.ace, kicker: Rank.ten),
          RankPair.suited(high: Rank.ace, kicker: Rank.jack),
          RankPair.suited(high: Rank.ace, kicker: Rank.queen),
          RankPair.suited(high: Rank.ace, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.five, kicker: Rank.five),
          RankPair.ofsuit(high: Rank.six, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.seven, kicker: Rank.seven),
          RankPair.ofsuit(high: Rank.eight, kicker: Rank.eight),
          RankPair.ofsuit(high: Rank.nine, kicker: Rank.nine),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
        HandRange({
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
        HandRange({
          RankPair.suited(high: Rank.eight, kicker: Rank.seven),
          RankPair.suited(high: Rank.nine, kicker: Rank.eight),
          RankPair.suited(high: Rank.seven, kicker: Rank.six),
          RankPair.ofsuit(high: Rank.ten, kicker: Rank.ten),
          RankPair.ofsuit(high: Rank.jack, kicker: Rank.jack),
          RankPair.ofsuit(high: Rank.queen, kicker: Rank.queen),
          RankPair.ofsuit(high: Rank.king, kicker: Rank.king),
          RankPair.ofsuit(high: Rank.ace, kicker: Rank.ace),
        }),
      ],
    );

    matchup = simulator.evaluate();
  }

  void teardown() {
    matchup = null;
  }

  void run() {
    matchup.bestHandIndexes;
  }
}

void main() {
  SimulatorInitializationBenchmark().report();
  SimulatorEvaluationBenchmark().report();
  MatchupBestHandEvaluationBenchmark().report();
}
